﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IndustryConnect.Bootcamp.Four
{
    class JobService : IJobService
    {
        private IJobReadyProgram _jobReadyProgram;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="jobReadyProgram">jobReadyProgram will be injected by Ninject according to the Setup in Program</param>
        public JobService(IJobReadyProgram jobReadyProgram)
        {
            _jobReadyProgram = jobReadyProgram;
        }

        public bool ApplyJob(IJobSeeker jobSeeker)
        {
            if (jobSeeker.ExperienceLevel > 0)
            {
                Console.WriteLine("{0} has gained the skills and experience.", jobSeeker.Name);
                InterviewInvitation(jobSeeker);
                return true; // Interview invited as successful outcome.
            }
            else
            {
                Console.WriteLine("{0}'s Experience is {1}", jobSeeker.Name, jobSeeker.ExperienceLevel);
                Console.WriteLine("{0} is Joining Job Ready Program", jobSeeker.Name);

                _jobReadyProgram.Join(jobSeeker);
            }

            return false; // unsuccessful outcome 
        }

        void InterviewInvitation(IJobSeeker jobSeeker)
        {
            // Invite the job seeker for inteview.
            Console.WriteLine("{0} is invited for interview.", jobSeeker.Name);
        }
    }
}
